import com.rinearn.graph3d.RinearnGraph3D;
import com.rinearn.graph3d.renderer.RinearnGraph3DRenderer;
import java.awt.Color;


/**
 * 描画エンジン（レンダラー）を直接操作して、
 * 3D空間内の自由な位置に点と線、三角形、および四角形を描画するサンプルです。
 */
public class Sample5 {
	
	public static void main(String[] args) {
		
		// グラフを起動してレンダラー（描画エンジン）を取得
		RinearnGraph3D graph = new RinearnGraph3D();
		RinearnGraph3DRenderer renderer = graph.getRenderer();
		
		// グラフ空間の範囲を設定
		graph.setXRange(1.0, 10.0);
		graph.setYRange(1.0, 10.0);
		graph.setZRange(1.0, 10.0);
		
		// グラフ空間内の(1,2,3)の位置に、半径10ピクセルで赤色の点を描画
		renderer.drawPoint(1.0,2.0,3.0, 10.0, Color.RED);
		
		// (1,1,1)と(8,8,5)の位置を結ぶ、太さ5ピクセルで緑色の線を描画
		renderer.drawLine(1.0,1.0,1.0, 8.0,8.0,5.0, 5.0, Color.GREEN);
		
		// (1,4,5)と(5,4,5)と(5,8,7)を結ぶ、青色の三角形を描画
		renderer.drawTriangle(1.0,4.0,5.0, 5.0,4.0,5.0, 5.0,8.0,7.0, Color.BLUE);
		
		// (5,1,1)と(8,1,1)と(8,4,1)と(5,4,1)を結ぶ、紫色の四角形を描画
		renderer.drawQuadrangle(5.0,1.0,1.0, 8.0,1.0,1.0, 8.0,4.0,1.0, 5.0,4.0,1.0, Color.MAGENTA);
		
		// スクリーンの再描画(3DCGレンダリング)
		renderer.render();
		
		
		// グラフを画像ファイルに出力したい場合は、以下を有効にしてください。
		/*
		try {
			graph.exportImageFile(new java.io.File("graph.png"), 1.0);
		} catch (java.io.IOException ioe) {
			System.err.println("ファイル出力に失敗しました。");
		}
		*/
	}
}
